config/routes.rb
if ENV['RAILS_RELATIVE_URL_ROOT']
  Rails.application.routes.default_scope = ENV['RAILS_RELATIVE_URL_ROOT']
end

Rails.application.routes.draw do
  get 'up', to: ->(env) { [204, {}, ['']] }

  # ------------------------------------------------------------ Authentication
  # Sign in / sign out
  get '/login'  => 'sessions#new'
  get '/logout' => 'sessions#destroy'
  resource :session

  resources :comments

  # ------------------------------------------------------------ Project routes
  concern :multiple_destroy do
    collection do
      delete :multiple_destroy
    end
  end

  concern :multiple_update do
    collection do
      patch :multiple_update
    end
  end

  concern :previewable do
    member do
      post :preview
    end
  end

  resources :notifications, only: [:index, :update]

  resources :projects, only: [:index, :show] do
    resources :activities, only: [:index] do
      collection do
        get :poll, constraints: { format: /js/ }
      end
    end

    resources :boards do
      resources :lists, except: [:index] do
        member { post :move }
        resources :cards, except: [:index] do
          member { post :move }
          resources :revisions, only: [:index, :show]
        end
      end
    end

    constraints id: %r{[(0-z)\/]+} do
      resources :configurations, only: [:index, :update]
    end

    post :create_multiple_evidence, to: 'issues/evidence#create_multiple'

    resources :issues, concerns: [:multiple_destroy, :previewable] do
      collection do
        post :import
        resources :merge, only: [:new, :create], controller: 'issues/merge'
      end

      resources :evidence, concerns: :multiple_destroy, controller: 'issues/evidence', only: [:index, :new]
      resources :nodes, only: [:show], controller: 'issues/nodes'
      resources :revisions, only: [:index, :show]
    end

    resources :methodologies do
      collection { post :preview }
      member do
        get :add
        put :update_task
      end
    end

    resources :nodes do
      collection do
        post :sort
        post :create_multiple
      end

      member do
        get :tree
      end

      resource :merge, only: [:create], controller: 'nodes/merge'

      resources :notes, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      resources :evidence, except: :index, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      constraints(filename: /.*/) do
        resources :attachments, only: [:index, :show, :create, :destroy], param: :filename
      end
    end

    resources :notifications, only: [:index, :update]

    resources :revisions, only: [] do
      member { post :recover }
    end

    resources :tags, except: [:show] do
      collection { post :sort }
    end

    namespace :qa do
      resources :issues, only: [:edit, :index, :show, :update], concerns: [:multiple_update, :previewable]
    end

    get 'search' => 'search#index'
    get 'trash' => 'revisions#trash'

    # ------------------------------------------------------- Export Manager
    get  '/export' => 'export#index', as: :export_manager

    # ------------------------------------------------------- Upload Manager
    get  '/upload'        => 'upload#index',  as: :upload_manager
    post '/upload'        => 'upload#create'
    post '/upload/parse'  => 'upload#parse'

    if Rails.env.development?
      get '/styles' => 'styles_tylium#index'
    end
  end

  resources :console, only: [] do
    collection { get :status }
  end

  resource :fields, only: [] do
    collection do
      get :field
      post :form
      post :source
    end
  end

  namespace :setup, only: [:index] do
    if defined?(Dradis::Pro)
    else
      resource :password, only: [:new, :create]
    end
    resource :kit, only: [:new, :create]
  end

  resources :subscriptions, only: [:index, :create, :destroy]

  # -------------------------------------------------------------- Static pages
  resource :markup, controller: :markup, only: [] do
    get :help
    post :preview
  end

  if defined?(Dradis::Pro)
  else
    root to: 'setup/passwords#new'
  end

  mount ActionCable.server => '/cable'
end

app/controllers/evidence_controller.rb
class EvidenceController < NestedNodeResourceController
  include AttachmentsCopier
  include ConflictResolver
  include EvidenceHelper
  include LiquidEnabledResource
  include Mentioned
  include MultipleDestroy
  include NodesSidebar
  include NotificationsReader

  before_action :set_or_initialize_evidence, except: [ :index, :create_multiple ]
  before_action :initialize_nodes_sidebar, only: [ :edit, :new, :show ]
  skip_before_action :find_or_initialize_node, only: [:create_multiple]
  before_action :set_auto_save_key, only: [:new, :create, :edit, :update]

  def show
    @issue = @evidence.issue

    load_conflicting_revisions(@evidence)
  end

  def new
    # See ContentFromTemplate concern
    @evidence.content = template_content if params[:template]
  end

  def create
    @evidence.author = current_user.email
    autogenerate_issue if evidence_params[:issue_id].blank?

    respond_to do |format|
      if @evidence.save
        track_created(@evidence)
        format.html {
          redirect_to [current_project, @evidence.node, @evidence],
            notice: "Evidence added for node #{@evidence.node.label}."
        }
      else
        format.html {
          initialize_nodes_sidebar
          render 'new'
        }
      end
      format.js
    end
  end

  def edit
    @form_preview_path = preview_project_node_evidence_path(current_project, @node, @evidence)
  end

  def update
    respond_to do |format|
      updated_at_before_save = @evidence.updated_at.to_i

      @evidence.assign_attributes(evidence_params)
      autogenerate_issue if evidence_params[:issue_id].blank?

      copy_attachments(@evidence) if @evidence.node_changed?

      if @evidence.save
        track_updated(@evidence)
        check_for_edit_conflicts(@evidence, updated_at_before_save)
        format.html do
          redirect_to evidence_redirect_path(params[:return_to]), notice: 'Evidence updated.'
        end

      else
        format.html {
          initialize_nodes_sidebar
          render 'edit'
        }
      end
      format.js
    end
  end

  def destroy
    respond_to do |format|
      if @evidence.destroy
        track_destroyed(@evidence)
        format.html {
          notice = "Successfully deleted evidence for '#{@evidence.issue.title}.'"
          # Evidence can be deleted from 3 places:
          # 1. from the issue evidence tab
          # 2. from the node evidence tab
          # 3. from the evidence show page itself (under node)
          # When using redirect_back in case 3, we find an evidence not found error,
          # since the evidence does not exist anymore. That's why we check the 'Referer' here:
          if request.headers['Referer'] == project_node_evidence_url(current_project, @node, @evidence)
            redirect_to project_node_path(current_project, @node), notice: notice
          else
            redirect_back fallback_location: project_node_path(current_project, @node), notice: notice
          end
        }
        format.js
      else
        format.html {
          redirect_to [current_project, @node, @evidence],
            notice: "Error while deleting evidence: #{@evidence.errors}"
        }
        format.js
      end
    end
  end

  private

  def autogenerate_issue
    @evidence.issue = Issue.autogenerate_from(@evidence)
    track_created(@evidence.issue)
  end

  def liquid_resource_assigns
    {
      'evidence' => EvidenceDrop.new(@evidence),
      'node' => NodeDrop.new(@evidence.node)
    }
  end

  # Look for the Evidence we are going to be working with based on the :id
  # passed by the user.
  def set_or_initialize_evidence
    if params[:id]
      @evidence = @node.evidence.includes(:issue, issue: [:tags]).find(params[:id])
    elsif params[:evidence]
      @evidence = Evidence.new(evidence_params) do |e|
        e.node = @node
      end
    else
      @evidence = Evidence.new(node: @node)
    end
  end

  def evidence_params
    params.require(:evidence).permit(:author, :content, :issue_id, :node_id)
  end

  def set_auto_save_key
    @auto_save_key =  if @evidence&.persisted?
      "evidence-#{@evidence.id}"
    elsif params[:template]
      "node-#{@node.id}-evidence-#{params[:template]}"
    else
      "node-#{@node.id}-evidence"
    end
  end
end

app/controllers/issues/evidence_controller.rb
class Issues::EvidenceController < AuthenticatedController
  include ActivityTracking
  include ContentFromTemplate
  include DynamicFieldNamesCacher
  include MultipleDestroy
  include ProjectScoped

  before_action :set_issues, only: [:create_multiple, :index, :new]
  before_action :set_affected_nodes, only: :index
  before_action :set_auto_save_key, only: :new
  before_action :set_columns, only: :index

  def index
    render layout: false
  end

  def new
    @nodes_for_add_evidence = current_project.nodes.user_nodes.order(:label)

    @template_content = template_content if params[:template]
  end

  def create_multiple
    # validate Issue
    @issue = current_project.issues.find(evidence_params[:issue_id])

    if node_params_empty?
      @content = evidence_params[:content]
      @nodes_for_add_evidence = current_project.nodes.user_nodes.order(:label)

      flash.now[:alert] = 'A node must be selected.'
      return render :new
    end

    if params[:evidence][:node_ids]
      params[:evidence][:node_ids].reject(&:blank?).each do |node_id|
        node = current_project.nodes.find(node_id)
        evidence = Evidence.create!(
          author: current_user.email,
          content: evidence_params[:content],
          issue_id: @issue.id,
          node_id: node.id
        )
        track_created(evidence)
      end
    end

    if params[:evidence][:node_list]
      if params[:evidence][:node_list_parent_id].present?
        parent = current_project.nodes.find(params[:evidence][:node_list_parent_id])
      end
      params[:evidence][:node_list].lines.map(&:strip).reject(&:blank?).each do |label|
        unless (node = current_project.nodes.find_by(label: label))
          node = current_project.nodes.create!(
            type_id: Node::Types::HOST,
            label: label,
            parent: parent,
          )
          track_created(node)
        end

        evidence = Evidence.create!(
          author: current_user.email,
          content: evidence_params[:content],
          issue_id: @issue.id,
          node_id: node.id
        )
        track_created(evidence)
      end
    end

    redirect_to project_issue_path(current_project, evidence_params[:issue_id], tab: 'evidence-tab'), notice: 'Evidence added for selected nodes.'
  end

  private

  def evidence_params
    params.require(:evidence).permit(:author, :content, :issue_id, :node_id)
  end

  def node_params_empty?
    params[:evidence][:node_list].blank? &&
      (params[:evidence][:node_ids].reject(&:empty?).empty?)
  end

  def set_columns
    default_field_names = ['Label', 'Title'].freeze
    extra_field_names = ['Created', 'Created by', 'Updated'].freeze

    dynamic_fields = dynamic_field_names(@issue.evidence)

    rtp = current_project.report_template_properties
    rtp_default_fields = rtp ? rtp.evidence_fields.default.field_names : []

    @default_columns = rtp_default_fields.presence || default_field_names
    @all_columns = rtp_default_fields | dynamic_fields | extra_field_names
  end

  def set_affected_nodes
    @affected_nodes = Node.joins(:evidence)
                          .select('nodes.id, label, type_id, count(evidence.id) as evidence_count, nodes.updated_at')
                          .where('evidence.issue_id = ?', @issue.id)
                          .group('nodes.id')
                          .sort_by { |node, _| node.label }
  end

  def set_auto_save_key
    @auto_save_key =  if params[:template]
      "issue-#{params[:issue_id]}-evidence-#{params[:template]}"
    elsif params[:from_rtp]
      "issue-#{params[:issue_id]}-rtp-evidence"
    else
      "issue-#{params[:issue_id]}-evidence"
    end
  end

  def set_issues
    @issues = current_project.issues.order(:text)
    @issue = @issues.find(params[:issue_id]) if params[:issue_id]
  end
end

app/controllers/issues/merge_controller.rb
class Issues::MergeController < IssuesController

  def new
    @issues = []

    if params[:ids]
      ids = params[:ids].split(',')
      @issues = Issue.where(id: ids)
    end

    if @issues.count <= 1
      redirect_to projects_issues_url(current_project),
        alert: 'You need to select at least two issues to merge.'
    end
  end

  def create
    count = 0
    if params[:sources]

      # create new issue if existing issue not given
      if @issue.new_record?
        @issue.author ||= current_user.email
        if @issue.save && @issue.update(issue_params)
          track_created(@issue)
          @issue.tag_from_field_content!
        end
      end

      if @issue.persisted?
        source_ids = params[:sources].map(&:to_i) - [@issue.id]
        count = @issue.merge source_ids
      end

    end

    respond_to do |format|
      format.html {
        if count > 0
          redirect_to [current_project, @issue], notice: "#{count} #{'issue'.pluralize(count)} merged into #{@issue.title}."
        else
          redirect_to project_issues_path(current_project), alert: "Issues couldn't be merged."
        end
      }
      format.json
    end
  end

  private
  def liquid_resource_assigns; {}; end
end

app/controllers/issues/nodes_controller.rb
class Issues::NodesController < AuthenticatedController
  include ProjectScoped

  def show
    @node =
      Node.joins(:evidence)
          .select('nodes.id, label, type_id,
                  count(evidence.id) as evidence_count, nodes.updated_at')
          .where('evidence.issue_id = ? and nodes.id = ?',
                 params[:issue_id], params[:id])
          .first
    @instances = Evidence.where(issue_id: params[:issue_id], node: @node)

    render layout: false
  end
end

app/helpers/evidence_helper.rb
module EvidenceHelper
  def evidence_redirect_path(return_to)
    if return_to == 'issue'
      [current_project, @evidence.issue]
    elsif @evidence.persisted?
      # @evidence.node_id might have changed (via Move) and can't
      # use the [] notation without an additional query to reload
      # the new Node.
      project_node_evidence_path(project_id: current_project.id, node_id: @evidence.node_id, id: @evidence.id)
    else
      [current_project, @node]
    end
  end
end

app/helpers/issues_helper.rb
module IssuesHelper
  # ------------------------------------------------------------ Import plugins
  # Takes the output of the ImportPlugin (an array of hashes (with :title,
  # :description, :tags for each record) and creates a new Issue object for
  # each element.
  def issues_from_import_records(records)
    issues = []
    records.each_with_index do |record, index|
      issue = Issue.new do |issue|
        issue.id = index
        if record.is_a?(Dradis::Plugins::Import::Result)
          issue.text = record.description
        else
          issue.text = record.fetch(:description,
                        "#[Title]#\nThis plugin did not provide its results in the expected format.\n\n#[Description]#\nWe expect and array of hashes: [{:title, :description}, ...]")
        end
      end

      if !issue.fields.key?('Title')
        # most likely this is some sort of error, try the record's :title
        if record.is_a?(Dradis::Plugins::Import::Result)
          issue.text << "\n\n#[Title]#\n#{record.title}"
        else
          issue.text << "\n\n#[Title]#\n#{record[:title]}"
        end
      end

      # The content of the entry can come with a Tags field, but the plugin
      # can also set some (e.g. the entry's status - 'Draft', 'Pending')
      if record.tags.any?
        tag_list = record.tags.join(',')
        issue.text << "\n\n#[AddonTags]#\n#{tag_list}"
      end

      issues << issue
    end
    issues
  end

  # Output Bootstrap badges if the issue has any associated tags
  def issue_tags(issue)
    return unless issue.fields.key?('Tags') || issue.fields.key?('AddonTags')

    all_tags = []

    %w{Tags AddonTags}.each do |tag_field|
      next unless issue.fields.key?(tag_field)
      content_tags = issue.fields[tag_field].split(',')
      all_tags << content_tags.map do |tag_name|
        tag = Tag.new(name: tag_name.strip)

        content_tag :span, class: 'badge', style: "background-color: #{tag.color}" do
          h(tag.display_name)
        end
      end
    end

    all_tags.join(' ').html_safe
  end

  # ----------------------------------------------------------- /Import plugins
  def tag_and_name_for(issue, prefix = false)
    content_tag :span, class: 'issue-severity' do
      tag = issue.tags.first
      content =
        if tag
          [
            colored_icon_for_model(issue, 'fa-tag'),
            h(tag.display_name)
          ]
        else
          [
            content_tag(:i, nil, class: 'fa-solid fa-tag'),
            'No tag'
          ]
        end

      if prefix == true
        content.insert(1, 'Issue')
        content[2] = "(#{content[2]})"
      end

      content.join(' ').html_safe
    end
  end

  def state_icons
    state_icons = []
    Issue.states.keys.each do |state|
      case state
      when 'draft'
        state_icons << ['Draft', 'fa-pencil-square']
      when 'ready_for_review'
        state_icons << ['Ready for review', 'fa-eye']
      when 'published'
        state_icons << ['Published', 'fa-rocket']
      end
    end
    return state_icons
  end
end

app/views/issues/evidence/_table.html.erb
<table class="table table-striped mb-0"
  data-behavior="dradis-datatable"
  data-default-columns="<%= @default_columns.to_json %>"
  data-item-name=<%= "issue_#{@issue.id}_evidence" %>
  data-local-storage-key="project.ce.<%= dom_id(current_project) %>.<%= "issue_#{@issue.id}_evidence_datatable" %>"
  >
  <thead>
    <tr>
      <th class="no-sort" data-column-visible="false"><span class="visually-hidden">Select</span></th>
      <% @all_columns.each do |column| %>
        <th><%= column %></th>
      <% end %>
      <th class="no-sort" data-column-visible="false"><span class="visually-hidden">Actions</span></th>
    </tr>
  </thead>
  <tbody>
    <% @affected_nodes.each do |node| %>
      <% node.evidence.where(issue_id: @issue.id).each do |evidence| %>
        <tr id="evidence-<%= evidence.id %>">
          <td class="select-checkbox" data-behavior="select-checkbox"></td>
          <% @all_columns.each do |column| %>
            <%
              sort, display =
              case column
              when 'Label'
                [evidence.node.label, link_to(evidence.node.label, [current_project, node, evidence])]
              when 'Created'
                [evidence.created_at.to_i, local_time_ago(evidence.created_at)]
              when 'Created by'
                [evidence.author, evidence.author]
              when 'Updated'
                [evidence.updated_at.to_i, local_time_ago(evidence.updated_at)]
              else
                [evidence.fields.fetch(column, ''), markup(evidence.fields.fetch(column, ''))]
              end
            %>
            <td data-sort="<%= sort %>"><%= display %></td>
          <% end  %>
          <td class="column-actions">
            <%= link_to edit_project_node_evidence_path(current_project, node, evidence, return_to: :issue) do %>
              <i class="fa-solid fa-pencil"></i> Edit
            <% end %>
            <%= link_to [current_project, node, evidence],
                  class: 'text-error-hover',
                  data: { confirm: "Are you sure?\n\nProceeding will delete this evidence from the associated node." },
                  method: :delete do %>
              <i class="fa-solid fa-trash"></i> Delete
            <% end %>
          </td>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

app/views/issues/evidence/index.html.erb
<h4 class="header-underline">Evidence information
  <span class="actions pt-1">
    <div class="action">
      <div class="dropdown">
        <%= link_to 'javascript:void(0)', class: 'dropdown-toggle', data: { bs_toggle: 'dropdown' } do %>
          <i class="fa-solid fa-plus"></i> New Evidence
        <% end %>
        <%= render 'shared/templates_dropdown',
          name: 'Evidence',
          new_path: new_project_issue_evidence_path(current_project, @issue),
          category_id: nil
        %>
      </div>
    </div>
  </span>
</h4>

<% if @issue.affected.any? %>
  <% cache ['issue-evidence-tab', @issue, @issue.evidence] do %>
    <div data-behavior="datatable-paths"
      data-table-destroy-url="<%= multiple_destroy_project_issue_evidence_index_path(current_project, @issue) %>"
      data-table-destroy-confirmation="Are you sure?&#10;&#10;Proceeding will delete the selected evidence."
      data-table-close-console-url="<%= project_issue_path(current_project, @issue, tab: 'evidence-tab') %>">
      <%= render 'issues/evidence/table' %>
    </div>
  <% end %>
<% else %>
  <div class="empty-state mt-3">
    <div class="empty-state-icon">
      <%= image_tag "icons/#{rand(9)}.svg" %>
    </div>
    <div class="empty-state-body">
      <div class="container">
        <h4 class="empty-state-title">This issue doesn't have any evidence yet</h4>
        <p class="empty-state-body-text">Use evidence to detail changes from one instance of the vulnerability to the next: port number, specific versions, banners grabbed by scanners, etc.</p>
        <div class="empty-state-actions">
          <a href="https://dradis.com/support/guides/projects/issues.html"
          class="empty-state-docs-link" target="_blank">More about issues and evidence</a>
        </div>
      </div>
    </div>
  </div>
<% end %>

app/views/issues/evidence/multiple_destroy.json.erb
<% if @count > @max_deleted_inline %>
{
  "success": true,
  "jobId": "<%= @job_logger.uid %>"
}
<% elsif @count > 0 %>
{
  "success": true,
  "msg": "<%= "Evidence deleted" %>"
}
<% else %>
{
  "success": false,
  "msg": "<%= "Error deleting Evidence" %>"
}
<% end %>

app/views/issues/evidence/new.html.erb
<% content_for :title, "Add new evidence for #{@issue.title}" %>

<% content_for :breadcrumbs do %>
  <nav>
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><%= link_to 'All issues', project_issues_path(current_project) %></li>
      <li class="breadcrumb-item"><%= link_to @issue.title, project_issue_path(current_project, @issue, tab: 'evidence-tab') %></li>
      <li class="breadcrumb-item active">New Evidence</li>
    </ol>
  </nav>
<% end %>

<% content_for :sidebar do %>
  <%= render 'issues/sidebar', issues: @issues %>
<% end %>

<%= form_for(
  :evidence,
  url: project_create_multiple_evidence_path(current_project),
  html: {
    id: 'add-evidences',
    data: {
      behavior: 'local-auto-save',
      auto_save_key: @auto_save_key
    }
  }
) do |f| %>
  <div class="content-container">
    <div id="issues_editor">
      <div class="note-text-inner">
        <h4 class="header-underline">Add new evidence</h4>
        <p class="mb-4 pb-3">Add evidence of <em><%= @issue.title ? @issue.title : "Issue ##{@issue.id}" %></em> by selecting or adding nodes below.</p>
        <div class="row">

          <div class="col-xl-4">
            <h5>Select existing nodes</h5>
            <% if @nodes.any? %>
              <div class="existing-node-list mb-3" data-behavior="add-evidence-container">
                <%= f.label :node, class: 'visually-hidden' %>
                <%= f.text_field :node, class: 'form-control existing-node-list-filter', placeholder: 'Type here to filter list...' %>
                <%= f.label :node_ids, class: 'visually-hidden' %>
                <%= f.collection_select :node_ids, @nodes_for_add_evidence, :id, :label, {}, { class: 'form-select', data: { behavior: 'existing-node-list'}, multiple: 'multiple' } %>
              </div>
            <% else %>
              <p>There are no existing nodes yet. <a href="#modal_add_branch_node" data-bs-toggle="modal" tabindex="-1">Create one</a>.</p>
            <% end %>
          </div>

          <div class="col-xl-4">
            <h5>
              Input new or existing nodes
              <span class="small">
                <i
                  class="fa-solid fa-question-circle"
                  data-bs-toggle="tooltip"
                  data-bs-html="true"
                  data-bs-placement="right"
                  role="tooltip"
                  title="<ul>
                  <li>If a node in this list already exists in the project, evidence will be added to it.</li>
                  <li>If a node doesn't exist, it will be created and then evidence will be added.</li>
                </ul>
                "
                >
              </i>
            </span>
          </h5>

          <%= f.label :node_list, class: 'visually-hidden' %>
          <%= f.text_area :node_list, rows: 7, placeholder: 'One node per line...', class: 'form-control mb-3' %>
        </div>

        <div class="col-xl-4">
          <h5>Create new nodes under</h5>
          <%= f.label :node_list_parent_id, class: 'visually-hidden' %>
          <%= f.collection_select(
                  :node_list_parent_id,
                  @nodes_for_add_evidence,
                  :id,
                  :label,
                  { include_blank: 'The root of the tree' },
                  { class: 'form-select' }
                ) %>
        </div>
      </div>

      <hr>

      <div class="row">
        <div class="col-12">
          <h5>Evidence Content</h5>
            <%= f.hidden_field :issue_id, value: @issue.id %>
            <%= f.hidden_field :node_id, value: @issue.node_id %>

            <%= f.label :content, nil, class: 'visually-hidden' %>
            <%= f.text_area :content,
                label: false,
                class: 'textile form-control',
                data: {
                  allow_dropdown: true,
                  behavior: 'auto-save rich-toolbar drop-zone',
                  paths: editor_paths,
                  'rich-toolbar': 'block-code bold field image italic link list-ol list-ul table',
                  'rich-toolbar-uploader': '[data-behavior~=jquery-upload]',
                },
                rows: 20,
                value: (@template_content || @content)
              %>
        </div>
      </div>
      <div class="row">
        <div class="col-12">
          <div class="form-actions">
            <%= f.submit 'Create Evidence', class: 'btn btn-primary' %> or
            <%= link_to 'Cancel', project_issue_path(current_project, @issue, tab: 'evidence-tab'), class: 'cancel-link', data: { behavior: 'clear-local-auto-save' } %>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<% end %>